# -*- coding: utf-8 -*-
"""newtest2.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1C756DGt1MlwTN7LJI_vX0nwkFduHKYUj
"""

# from google.colab import drive
# drive.mount('/content/drive')

import pandas as pd
import json

openfile=open('house.json',encoding='utf8')
jsondata=json.load(openfile)
data=pd.DataFrame(jsondata)
# data = pd.read_json('/content/drive/My Drive/Colab Notebooks/output2_2020-05-30_12.json', lines=True, encoding='utf8')



import re
# from nltk import word_tokenize
import numpy as np
# data = pd.read_csv("a123nhadatviet1-extract2.csv")
# print(data.info())

data = data.dropna(axis = 0, subset=["price","addr_street"])
data = data.drop(data[(data["price"] == "") | (data["addr_street"] == "")].index)

# print(data.info())

# def price_process(price,index):
# 	char = "(tr|triệu|trieu|tỉ|ti|tỷ|ty)"
# 	char1 = "(tr|triệu|trieu)"
# 	char2 = "(tỉ|ti|tỷ|ty)"
	
# 		# res = re.findall("[0-9]+.?[0-9]+"+x+ )
# 	# res = re.search("[0-9]+.?[0-9]+"+ char +"?"+"([0-9]+.?[0-9]+)?",price)
# 	# print(price)
	
# 	res = re.search(r'\d+', price)
# 	if res:
# 		if re.search(char2,price) and "/" not in price  and "m2" not in price and"m" not in price:
# 			# newres = re.findall("([0-9]+.?[0-9]+tỉ[0-9]+.?[0-9]+|[0-9]+.?[0-9]+tỉ)|([0-9]+.?[0-9]+ti[0-9]+.?[0-9]+|[0-9]+.?[0-9]+ti)|([0-9]+.?[0-9]+ty[0-9]+.?[0-9]+|[0-9]+.?[0-9]+ty)|([0-9]+.?[0-9]+tỷ[0-9]+.?[0-9]+|[0-9]+.?[0-9]+tỷ)|[0-9]+.?[0-9]",price)
# 			# for y in newres			
# 			if len(re.findall(char2,price)) == 1:
# 				temp = re.findall("[0-9]+[.][0-9]+|[0-9]+", price)
# 				res1 = list(map(float, temp))
# 				if len(res1) == 1:
# 					return res1[0]
# 				elif len(res1) > 1:
# 					if re.search(char2+"[0-9]+",price) and res1[1] >= 10 and res1[1] <= 999 and len(res1) == 2:
# 						return res1[0] + res1[1]/1000
# 					elif re.search(char2+"[0-9]+",price)  and len(res1) == 2  and int(res1[1]/10) == 0:
# 						return res1[0] + res1[1]/10
# 					# print(price)
# 					newtemp = re.search("tỉ.*|ti.*|ty.*|tỷ.*",price)
# 					newtemp = re.sub("tỉ|ti|tỷ|ty","",newtemp.group())
# 					# if len(newtemp)!= 0:
# 					price1 = price.replace(newtemp,"")
# 					# print(price1)
# 					if re.search(char1,price1):
# 						# temp1 = re.findall("[0-9]+[.][0-9]+|[0-9]+",price)
# 						# print(price1)
# 						temp1 = re.findall("[0-9]+[.]?[0-9]*tr+|[0-9]+[.]?[0-9]*trieu|[0-9]+[.]?[0-9]*triệu|[0-9]+[.]?[0-9]*",price1)
# 						count = 0
# 						# print(temp1)
# 						for x in temp1[0:-1]:
# 							count += float(re.sub("tr|triệu|trieu","",x))/1000 if re.search("tr|triệu|trieu",x) else float(x)
# 						# print(temp1[-1])
# 						if re.search("tr|triệu|trieu",temp1[-1]):
# 							# print(temp1[-1])
# 							temp1[-1] = re.sub("tr|triệu|trieu","",temp1[-1])
# 							temp1[-1] = float(temp1[-1])/1000
# 						# print(temp1[-1])
# 						count = (count + float(temp1[-1]))/len(temp1)
# 						return count
# 					elif "-" in price1:
# 						price1 = price1.replace("-",",")
# 						# temp1 = re.findall(r'\d+',price1)
# 						temp1 = re.findall("[0-9]+[.][0-9]*|[0-9]+",price1)
# 						count = 0
# 						for x in temp1:
# 							count += float(x)
# 						return count/len(temp1)
# 					elif re.search("([0-9]+[.])+[0-9]+",price1):
# 						temp1 = re.search("([0-9]+[.])+[0-9]+",price1).group()
# 						temp1 = temp1.replace(".","")
# 						return float(temp1)/(10**9) if len(temp1) != 10 else price
# 					else:
# 						# temp1 = re.findall(r'\d+',price1)
# 						temp1 = re.findall("[0-9]+[.][0-9]*|[0-9]+",price1)
# 						count = 0
# 						for x in temp1:
# 							count +=  float(x)
# 						return count/len(temp1)
# 				else:
# 					return price
# 			elif len(re.findall(char2,price)) > 1:
# 				temp = re.findall("[0-9]+[.][0-9]+|[0-9]+", price)
# 				res1 = list(map(float, temp))
# 				res2 = re.sub("tỉ|ti|tỷ|ty","tỷ",price)
# 				res2 = re.sub("triệu|trieu|tr","triệu",price)
# 				if len(res1) == 1:
# 					return res1[0]
# 				elif len(res1) > 1:
# 					newtemp = re.findall("[0-9]+[.]?[0-9]*tỷ|[0-9]+[.]?[0-9]*tỷ[0-9]+|[0-9]+[.]?[0-9]*",res2)
# 					count = 0
# 					# print(newtemp)
# 					for x in newtemp:
						
# 						if not "tỷ" in x and re.search("[0-9]+|[0-9]+.[0-9]+",x) and not"-" in x:
# 							count += price_process(x + "tỷ",index)
# 						else:
# 							# print(x)
# 							count += price_process(x,index)
					
# 					return count
# 		elif re.search(char1,price) and not re.search("tháng|th|thang",price):
			
# 			if "/" not in price  and "m2" not in price and"m" not in price:
# 				res2 = re.sub("triệu|trieu|tr","triệu",price)
# 				temp1 = re.sub("triệu","tỷ",res2)
# 				temp2 = price_process(temp1,index)
# 				# print(price)
# 				# counter -= 1
# 				if not type(temp2) is str:
# 					return temp2/1000
# 				else:

# 					# print(price)
# 					return price
# 			else:
# 				# print(price)
# 				res2 = re.sub("triệu|trieu|tr","triệu",price)
# 				# print(res2)
# 				temp1 = re.sub("triệu","tỷ",res2)
# 				# print(temp1)
# 				temp1 = re.sub("m2|m|[/]","",temp1)
# 				# print(temp1)
# 				temp2 = price_process(temp1,index)
# 				# counter -= 1
# 				area = data["area"].iloc[index]
# 				area = re.search("[0-9]+[.][0-9]+|[0-9]+",str(area))
# 				if not type(temp2) is str and area:
# 					area = float(area.group())
# 					return temp2/1000 * area
# 				else:
# 					# print(price)
# 					return price
# 		else:
# 			# print(price)
# 			temp = data['title'].iloc[index]
# 			# print(temp)
# 			temp = temp.lower()
# 			newtemp = word_tokenize(temp)
# 			arr = ["tỉ" , "ti" , "tỷ" , "ty" , "triệu" , "trieu" , "tr"]

# 			for x in arr:
# 				if x in newtemp:
# 					val = newtemp[newtemp.index(x) - 1]
# 					# print(val)
# 					if newtemp.index(x) < len(newtemp) -1:
# 						val1 = newtemp[newtemp.index(x) + 1]
# 					else :
# 						val1 = [""]
# 					if val.isdigit():
# 						if val1[0].isdigit():
# 							return float(val) + float(val1[0])/1000 if not x in arr[4:] else float(val)/1000
# 						else:
# 							return float(val) if not x in arr[4:] else float(val)/1000
# 					elif re.search("[0-9]+([.,][0-9]+)?",val):
# 						newval = val.replace(",",".")
# 						newval = re.findall("[0-9]+[.][0-9]+|[0-9]+",newval)
# 						# print(temp)
# 						if val1[0].isdigit():
# 							return float(newval[0]) + float(val1[0])/1000 if not x in arr[4:] else float(newval[0])/1000
# 						else:
# 							return float(newval[0]) if not x in arr[4:] else float(newval[0])/1000
# 				# return val
# 			return price
# 	else:
# 		# print(price)
# 		# print(newdf['title'].iloc[counter-1])
# 		temp = data['title'].iloc[index]
# 		# print(temp)
# 		temp = temp.lower()
# 		newtemp = word_tokenize(temp)
# 		arr = ["tỉ" , "ti" , "tỷ" , "ty" , "triệu" , "trieu" , "tr"]

# 		for x in arr:
# 			if x in newtemp:
# 				val = newtemp[newtemp.index(x) - 1]
# 				# print(val)
# 				if newtemp.index(x) < len(newtemp) -1:
# 					val1 = newtemp[newtemp.index(x) + 1]
# 				else:
# 					val1 = [""]
# 				if val.isdigit():
# 						# print(temp)
# 						# print(val)
# 					if 	val1[0].isdigit():
# 						return float(val) + float(val1[0])/1000 if not x in arr[4:] else float(val)/1000
# 					else:
# 						return float(val) if not x in arr[4:] else float(val)/1000
# 				elif re.search("[0-9]+([.,][0-9]+)?",val):
# 					newval = val.replace(",",".")
# 					newval = re.findall("[0-9]+[.][0-9]+|[0-9]+",newval)
# 					if val1[0].isdigit():
# 						return float(newval[0]) + float(val1[0])/1000 if not x in arr[4:] else float(newval[0])/1000
# 					else:
# 						return float(newval[0]) if not x in arr[4:] else float(newval[0])/1000
# 		# print(temp)		# return val
# 		return price
# def price_proceed(price,index):
# 	char1 = "(ngàn|ngan|nghìn|nghin)"
# 	char2 = "(tháng|thang)"
# 	char3 = "(tr|triệu|trieu)"
	
# 	if re.search(r'\d+',price):
# 		if re.search(char2,price):
# 			if  not "m2" in price  :
# 				# area = float(re.search("[0-9]+[.][0-9]+|[0-9]+",df["area"].iloc[counter - 1]).group())
# 				if re.search(char3,price):
# 					temp = re.sub("triệu|trieu|tr","triệu",price)
# 					temp = temp.replace("-",",")
# 					newtemp = re.findall("[0-9]+[.][0-9]*|[0-9]+",temp)
# 					newtemp = list(map(float, newtemp))
# 					if len(newtemp) == 1:
# 						return newtemp[0]
# 					elif len(newtemp) > 1:
# 						if re.search("triệu[0-9]+",temp) and newtemp[1] >= 10 and newtemp[1] <= 999 and len(newtemp) == 2:
# 							return newtemp[0] + newtemp[1]/1000 
# 						elif re.search("triệu[0-9]+",temp)  and len(newtemp) == 2  and int(newtemp[1]/10) == 0:
# 							return newtemp[0] + newtemp[1]/10 
# 						newtemp1 = re.search("triệu*",temp)
# 						newtemp1 = re.sub("triệu","",newtemp1.group())
# 						price1 = temp.replace(newtemp1,"")
# 						# else:
# 						# 	return price
# 						if re.search("([0-9]+[.])+[0-9]+",price1):
# 							temp1 = re.search("([0-9]+[.])+[0-9]+",price1).group()
# 							temp1 = temp1.replace(".","")
# 							return float(temp1)/(10**6) if len(temp1) != 7 else price
# 						else:
# 							# price1 = price1.replace("-",",")
# 								# temp1 = re.findall(r'\d+',price1)
# 							temp1 = re.findall("[0-9]+[.][0-9]*|[0-9]+",price1)
# 							count = 0
# 							for x in temp1:
# 								count += float(x)
# 							return count/len(temp1)
# 					else:
# 						return price
# 				elif re.search(char1,price):
# 					temp = re.sub("ngàn|ngan|nghìn|nghin","ngàn",price)
# 					temp = re.sub("ngàn","triệu",temp)
					
# 					temp = price_proceed(temp,index)
# 					return (temp/1000) if not type(temp) is str else price
# 				else:
# 					return price
# 			check = data["area"].iloc[index]
# 			check = re.search("[0-9]+[.][0-9]+|[0-9]+",str(check))
# 			if "m2" in price and check:
# 				# print(price)
# 				area = float(check.group())
# 				temp = re.sub("m2","",price)
				
# 				temp = price_proceed(temp,index)
# 				return temp *area if not type(temp) is str else price
# 			else:
# 				return price
# 		else :
# 			temp = price + "tháng"
			
# 			return price_proceed(temp,index)
# 	else:
# 		 return price
# def change_type(data):
# 	for i,row in data.iterrows():
# 		if "ban" in row["realestate_url"] or "thue" in row["realestate_url"] :
# 			# print(row["realestate_url"])
# 			data.at[i,"transaction_type"] = check_type(row["realestate_url"])
# 			# print(row["transaction_type"])
# 		elif "ban" in row["start_url"] or "thue" in row["start_url"]:
# 			data.at[i,"transaction_type"] = check_type(row["start_url"])
# 		if data.at[i,"transaction_type"] == "bán":
# 			data.at[i,"price"] = price_process(row["price"],i)
# 			# print(row["price"])
# 			if type(data.at[i,"price"]) is str:
# 				data.at[i,"price_unit"] = np.nan
# 			else:
# 				data.at[i,"price_unit"] = "tỷ"
# 		else:
# 			data.at[i,"price"] = price_proceed(row["price"],i)
# 			if type(data.at[i,"price"]) is str:
# 				data.at[i,"price_unit"] = np.nan
# 			else:
# 				data.at[i,"price_unit"] = "triệu/tháng"	
# 	return data
# def check_type(data):
# 	if "ban" in data:
# 		return "bán"
# 	else:
# 		return "thuê"
# data.drop_duplicates(subset=['realestate_type', 'transaction_type', 'addr_city', 'addr_ward', 'addr_district', 'addr_street', 'price'], inplace=True)
data = data.reset_index(drop=True)
# data = change_type(data)
# print(data['price_unit'].isnull().sum())


###########

# for x in df.index:
# 	print(x)

# print(df["price"].isnull().sum())
# for x in newdf.index:
# 	print(x)



# for x in newdf["price"]:
# 	print(x)
# print(newdf["price"].isnull().sum())

# print(df["price"].isnull().sum())



# ######################

# data.drop_duplicates(subset=['realestate_type', 'transaction_type', 'addr_city', 'addr_ward', 'addr_district', 'addr_street', 'price'], inplace=True)


 #output dataframe

data.drop(data[data["price_unit"].isnull()].index, axis=0, inplace=True)

data.drop(data[data["area"].isnull()].index,axis=0, inplace=True)
data.drop(data[data["area"] == ""].index,axis=0, inplace=True)

data.isnull().sum()

# data[data["addr_city"] == "Hồ Chí Minh"]

# data["addr_city"].value_counts()

def change_realestate_type(data):
  check = "(nhà|đất|căn hộ)"
  dic = {"nha":"nhà","can-ho":"căn hộ","dat":"đất","tro":"trọ",None:np.nan}
  for i,row in data.iterrows():
    if not re.search("^"+check+"$",str(row["realestate_type"])):
      data.at[i,"realestate_type"] = dic[look_up(row["realestate_url"])]
  return data

def look_up(value):
  check = "tro|nha|can-ho|dat"
  result = re.search(check,value)
  if result:
#     print(result.group())
    return result.group()
  else:
    return None

data = change_realestate_type(data)

# data["realestate_type"].value_counts()

# data.isnull().sum()

# data["addr_city"].value_counts()

# data = data[(data["addr_city"] == "Hồ Chí Minh") | (data["addr_city"] == "Hà Nội")]

data.info()

data = data.dropna(axis = 0, subset=["price","addr_city","addr_district","realestate_type"])

data.drop(data[(data["addr_city"] == "")|(data["addr_district"] == "")|(data["realestate_type"] == "")].index,inplace = True)

def isnumber(value):
  try:
    float(value)
    return float(value)
  except ValueError:
    return np.nan
    
data["area"] = data["area"].apply(isnumber)

data["area"].isnull().sum()

data = data.dropna(axis = 0, subset=["area"])
data.count()

data = data[data['area'] > 0]

data["area"].value_counts()

data[(data["interior_room"] == "") & (data["interior_floor"] == "")]

# inter = data['interior_floor'].values.tolist()

# mask2 = list(map(lambda x: True if x != '' else False, inter))
# inter = list(filter(lambda x: x != '', inter))
# inter

# new_inter = list(map(lambda x: x.replace(' ','-').replace('-', '--').split('--'), inter))
# new_inter = list(map(lambda x: list(filter(lambda y: y != '', x)), new_inter))
# new_inter = list(filter(lambda x: len(x) > 0, new_inter))
# # print(new_inter[0:5])
# for _ in new_inter:
#   for st in _:
#     if st == 't':
#       _[_.index(st)] = 'tầng'
#     elif st in ['lau', 'l']:
#       _[_.index(st)] = 'lầu'
#     elif st == 'tret':
#       _[_.index(st)] = 'trệt'
#     elif st == 'pn':
#       _[_.index(st)] = 'phòng'
#     elif st in ['lững','lung']:
#       _[_.index(st)] = 'lửng'
#     elif st in [ 'balcon', 'balcone','balcony', 'ban']:
#       _[_.index(st)] = 'ban công'
# #     else: 
# #       if not st.isnumeric():
# #         _.remove(st)
# mask = []
# for _ in new_inter:
#   flag = False
#   for st in _:
#     if st in ['trệt', 'phòng', 'lửng', 'ban', 'công', 'lầu','tầng',"ban công","sân","thượng"]:
#       flag = True
#       mask.append(True)
#       break
#   if not flag:
#     mask.append(True)
  
  
# new_inter = np.array(new_inter)[mask]

# data1 = data[mask2]
# data2 = data1[mask]

# from mlxtend.preprocessing import TransactionEncoder
# from mlxtend.frequent_patterns import apriori

# transaction_encode = TransactionEncoder()
# encoded = transaction_encode.fit(new_inter).transform(new_inter)
# encoded = np.array(encoded)
# transaction_encode.columns_

# encoded_data = pd.DataFrame(encoded, columns=transaction_encode.columns_)
# encoded_data

# frequent_itemset = apriori(encoded_data, min_support=0.01,use_colnames=True, max_len=1)
# # frequent_itemset['itemsets'] = frequent_itemset['itemsets'].apply(lambda x: ','.join(list(x)))
# # frequent_itemset.to_csv('frequent_itemset.csv')
# frequent_itemset

# t = data[~data['interior_floor'].str.contains('tầng', regex=True)]
# t

def change_interior_floor1(data):
	new_inter =  data.replace(' ','-').replace('-', '--').split('--')
	# new_inter = list(map(lambda x: list(filter(lambda y: y != '', x)), new_inter))
	# new_inter = list(filter(lambda x: len(x) > 0, new_inter))

	for st in new_inter:
		if st == 't':
			new_inter[new_inter.index(st)] = 'tầng'
		elif st in ['lau', 'l']:
			new_inter[new_inter.index(st)] = 'lầu'
		elif st == 'tret':
			new_inter[new_inter.index(st)] = 'trệt'
		elif st == 'pn':
			new_inter[new_inter.index(st)] = 'phòng'
		elif st in ['lững','lung']:
			new_inter[new_inter.index(st)] = 'lửng'
		elif st in [ 'balcon', 'balcone','balcony', 'ban']:
			new_inter[new_inter.index(st)] = 'ban công'
	return new_inter
def change_interior_floor(data):
	for i,row in data.iterrows():
		check = change_interior_floor1(str(row["interior_floor"]))
		if "tầng" in check or "lầu" in check:
			for x in check:
				if x == "tầng" or x == "lầu":
					try:
						temp = int(check[check.index(x)-1])
						data.at[i,"tang"] = temp
					except ValueError:
						data.at[i,"tang"] = change_interior_floor2(data,str(row["title"]))
		elif re.search("[0-9]+tầng|[0-9]+lầu",str(row["interior_floor"])):
				temp = re.findall("([0-9]+)tầng|([0-9]+)lầu",str(row["interior_floor"]))
				temp = list(map(int, temp))
				return max(temp)
		else:
			data.at[i,"tang"] = change_interior_floor2(data,str(row["title"]))
		if "ban công" in check or "công" or "ban" in check:
			data.at[i,"ban_cong"] = 1
		else:
			data.at[i,"ban_cong"] = 0
		if "sân" in check or "thượng" in check or "sân thượng" in check:
			data.at[i,"san_thuong"] = 1
		else:
			data.at[i,"san_thuong"] = 0
	return data
def change_interior_floor2(data,val):
	value = val.lower()
	# value = word_tokenize(value)
	value = value.split()
	for i in enumerate(value):
		if i[1] == "tầng" or i[1] == "lầu":
			try:
				return int(value[i[0] - 1])
			except:
				return 0
		elif re.search("([0-9])+t$|([0-9])+l$",i[1]):
			print(i[1])
			temp = re.findall("([0-9]+)t$|([0-9])+l$",i[1])
			print(temp)
			try:
				return int(temp[0][0])
			except ValueError:
				return 0
		else:
			return 0
		

data = change_interior_floor(data)
		

	# 	if "ban" in row["realestate_url"] or "thue" in row["realestate_url"] :
	# 		# print(row["realestate_url"])
	# 		data.at[i,"transaction_type"] = check_type(row["realestate_url"])
	# 		# print(row["transaction_type"])
	# 	elif "ban" in row["start_url"] or "thue" in row["start_url"]:
	# 		data.at[i,"transaction_type"] = check_type(row["start_url"])
	# 	if data.at[i,"transaction_type"] == "bán":
	# 		data.at[i,"price"] = price_process(row["price"],i)
	# 		# print(row["price"])
	# 		if type(data.at[i,"price"]) is str:
	# 			data.at[i,"price_unit"] = np.nan
	# 		else:
	# 			data.at[i,"price_unit"] = "tỷ"
	# 	else:
	# 		data.at[i,"price"] = price_proceed(row["price"],i)
	# 		if type(data.at[i,"price"]) is str:
	# 			data.at[i,"price_unit"] = np.nan
	# 		else:
	# 			data.at[i,"price_unit"] = "triệu/tháng"	
	# return data

# data[data['interior_room']==""]

# inter = data['interior_room'].values.tolist()
# inter

# data.info()
def preprocess(price):
	if type(price) is str:
		val = re.findall("[0-9]+|[0-9]+[.][0-9]*",price)
		res = list(map(float, val))
		if val:
			maximum = max(res)
			return maximum if maximum < 100 else np.nan
		else:
			return np.nan
	else:
		return price
data["price"] = data["price"].apply(preprocess)
data = data.dropna(axis = 0, subset=["price"])
data.reset_index(drop = True)
data["price"] = data["price"].astype('float64')

print(data.info())
# newdata = pd.get_dummies(data, columns=['addr_city', 'addr_district', 'addr_street','addr_ward'])
# newdata = pd.get_dummies(data, columns=['addr_city', 'addr_district'],drop_first=True)
# data = data.reset_index(drop= True)
# from sklearn.feature_extraction import DictVectorizer
# from sklearn.base import TransformerMixin
# from sklearn.pipeline import make_pipeline
# class RowIterator(TransformerMixin):
#     def fit(self, X, y=None):
#         return self
#     def transform(self, X):
#         return (row for _, row in X.iterrows())
# le = make_pipeline(RowIterator(), DictVectorizer(sparse=True))
# temp = le.fit_transform(data[['addr_city', 'addr_district']])
# # # data["addr_city"] = le.fit_transform(data["addr_city"])
# data = pd.concat([data, pd.DataFrame(data=temp.toarray())], axis=1, sort=False)
newdata = data
newdata

newdata1 = newdata[newdata["transaction_type"] == "bán"]

newdata1 = newdata1.drop(columns =['index','geo_location','interior_floor','addr_street','addr_ward',"area_unit","date","email","interior_room","legal","phone","position","potential","realestate_url","start_url","surrounding","surrounding_characteristics","surrounding_name","title","transaction_type","website_name","price_unit"])

newdata1.reset_index(drop = True, inplace = True)
train_numerical = newdata1.select_dtypes(exclude=['object','datetime64[ns]'])

train_categoric = newdata1.select_dtypes(include=['object'])

from sklearn.ensemble import IsolationForest

clf = IsolationForest(max_samples = 100, random_state = 42)
clf.fit(train_numerical)
y_noano = clf.predict(train_numerical)
y_noano = pd.DataFrame(y_noano, columns = ['Top'])
y_noano[y_noano['Top'] == 1]

train_numerical = train_numerical.iloc[y_noano[y_noano['Top'] == 1].index.values]
train_numerical.reset_index(drop = True, inplace = True)

train_categoric = train_categoric.iloc[y_noano[y_noano['Top'] == 1].index.values]
train_categoric.reset_index(drop = True, inplace = True)

newdata1 = newdata1.iloc[y_noano[y_noano['Top'] == 1].index.values]
newdata1.reset_index(drop = True, inplace = True)

col_train_num = list(train_numerical.columns)
col_train_num_bis = list(train_numerical.columns)

col_train_cat = list(train_categoric.columns)

col_train_num_bis.remove('price')

mat_train = np.matrix(train_numerical)
# mat_test  = np.matrix(test_numerical)
mat_new = np.matrix(train_numerical.drop('price',axis = 1))
mat_y = np.array(newdata1.price)

# mat_y = np.array([mat_y])
# mat_y= mat_y.T
mat_y.shape

from sklearn.preprocessing import MinMaxScaler
prepro_y = MinMaxScaler()
# prepro_y.fit([mat_y])
prepro_y.fit(mat_y.reshape(mat_y.shape[0],1))

prepro = MinMaxScaler()
prepro.fit(mat_train)

prepro_test = MinMaxScaler()
prepro_test.fit(mat_new)

train_num_scale = pd.DataFrame(prepro.transform(mat_train),columns = col_train_num)
# test_num_scale  = pd.DataFrame(prepro_test.transform(mat_test),columns = col_train_num_bis)
newdata1[col_train_num] = pd.DataFrame(prepro.transform(mat_train),columns = col_train_num)
# newdata1["price"] = pd.DataFrame(prepro_y.transform(mat_y.reshape(mat_y.shape[0],1)),columns = ["price"])

COLUMNS = col_train_num
FEATURES = col_train_num_bis
LABEL = "price"

FEATURES

FEATURES_CAT = col_train_cat
FEATURES_CAT

import tensorflow as tf
engineered_features = []

for continuous_feature in FEATURES:
    engineered_features.append(
        # tf.contrib.layers.real_valued_column(continuous_feature))
        tf.feature_column.numeric_column(continuous_feature))
for categorical_feature in FEATURES_CAT:
    # sparse_column = tf.contrib.layers.sparse_column_with_hash_bucket(
    #     categorical_feature, hash_bucket_size=1000)
    sparse_column = tf.feature_column.categorical_column_with_hash_bucket(
        categorical_feature, hash_bucket_size=1000)

    engineered_features.append(tf.feature_column.embedding_column(categorical_column=sparse_column, dimension=4,combiner="sum"))

training_set = newdata1[FEATURES + FEATURES_CAT]
prediction_set = newdata1.price

from sklearn.model_selection import train_test_split
x_train, x_test, y_train, y_test = train_test_split(training_set[FEATURES + FEATURES_CAT] ,
                                                    prediction_set, test_size=0.33, random_state=42)

y_train = pd.DataFrame(y_train, columns = [LABEL])
training_set = pd.DataFrame(x_train, columns = FEATURES + FEATURES_CAT).merge(y_train, left_index = True, right_index = True)

y_test = pd.DataFrame(y_test, columns = [LABEL])
testing_set = pd.DataFrame(x_test, columns = FEATURES + FEATURES_CAT).merge(y_test, left_index = True, right_index = True)
training_set[FEATURES_CAT] = training_set[FEATURES_CAT].applymap(str)
testing_set[FEATURES_CAT] = testing_set[FEATURES_CAT].applymap(str)
# training_set= training_set.applymap(str)
# testing_set = testing_set.applymap(str)

training_set.info()

def input_fn_new(data_set, training = True):
    continuous_cols = {k: tf.constant(data_set[k].values, dtype=tf.float64) for k in FEATURES}

    categorical_cols = {k: tf.SparseTensor(
        indices=[[i, 0] for i in range(data_set[k].size)], values = data_set[k].values, dense_shape = [data_set[k].size, 1]) for k in FEATURES_CAT}

    # Merges the two dictionaries into one.
    feature_cols = dict(list(continuous_cols.items()) + list(categorical_cols.items()))

    if training == True:
        # Converts the label column into a constant Tensor.
        label = tf.constant(data_set[LABEL].values)

        # Returns the feature columns and the label.
        return feature_cols, label

    return feature_cols

# training_set = np.expand_dims(np.asarray(training_set),-1)
# training_set.shape
input_fn_new(training_set)

import os
regressor = tf.estimator.DNNRegressor(feature_columns = engineered_features,
                                          activation_fn = tf.nn.relu6, hidden_units=[1], optimizer=tf.keras.optimizers.SGD( learning_rate= 0.025), dropout=0.01,model_dir = "./ban")

os.getcwd()

categorical_cols = {k: tf.SparseTensor(indices=[[i, 0] for i in range(training_set[k].size)], values = training_set[k].values, dense_shape = [training_set[k].size, 1]) for k in FEATURES_CAT}

train =regressor.train(input_fn = lambda:input_fn_new(training_set) ,steps = 2000)
# print("train_accuracy",train['prediction/mean'])


ev = regressor.evaluate(input_fn=lambda: input_fn_new(testing_set, training = True), steps=1)
print("eval_accuracy",ev['prediction/mean'])
# new_regressor = tf.estimator.DNNRegressor(feature_columns = engineered_features,
                                          # activation_fn = tf.nn.relu6, hidden_units=[1], optimizer=tf.keras.optimizers.SGD( learning_rate= 0.025), dropout=0.01,model_dir = os.getcwd())

# nev = new_regressor.evaluate(input_fn=lambda: input_fn_new(testing_set, training = True), steps=1)

# BIN_MODEL_DIR = "/content/drive/My Drive"
# serving_input_receiver_fn = tf.estimator.export.build_parsing_serving_input_receiver_fn(feature_spec= tf.feature_column.make_parse_example_spec(engineered_features))
# regressor.export_saved_model(export_dir_base = BIN_MODEL_DIR,serving_input_receiver_fn = serving_input_receiver_fn)

# imported = tf.saved_model.load("/content/drive/My Drive/1595529266")

# [x.name for x in imported.variables.trainable_variables]
# pruned = imported.prune("dnn/input_from_feature_columns/input_layer/addr_city_embedding/embedding_weights:0", "dnn/logits/bias:0")

# imported = imported.signatures
# tf.train.list_variables(imported)

FEATURES_CAT

# def predict(x):
#   lst = FEATURES
#   newlst = FEATURES_CAT
#   examples = dict()
#   count = 0
#   for i,name in enumerate(lst):
#     example = tf.train.Example()
#     example.features.feature[name].float_list.value.extend([x[count]])
#     # examples.append(tf.constant([example.SerializeToString()]))
#     examples[name] = tf.constant([example.SerializeToString()])
#     count = count + 1
#   for i,name in enumerate(newlst):
#     example = tf.train.Example()
#     example.features.feature[name].bytes_list.value.extend([x[count]])
#     # examples.append(tf.SparseTensor(
#     #     indices=[[1,0]], values = [example.SerializeToString()], dense_shape = [1, 1]))
#     examples[name] = tf.SparseTensor(
#         indices=[[1,0]], values = [example.SerializeToString()], dense_shape = [1, 1])
#     count = count + 1
#     # np_list = np.asarray(examples)
#     # tensor_list = tf.convert_to_tensor(np_list)
#   return imported.signatures["predict"](examples=examples)

# predict([40,4,0,1,b"Quan 3",b"Ho Chi Minh",b"nha"])

loss_score4 = ev["loss"]
print("Final Loss on the testing set: {0:f}".format(loss_score4))

# newdata1 = newdata1.drop(columns =['addr_street','addr_ward',"area_unit","date","email","interior_floor","interior_room","legal","phone","position","potential","realestate_url","start_url","surrounding","surrounding_characteristics","surrounding_name","title","transaction_type","website_name","price_unit"])

# newdata1

# newdata1["tầng"].value_counts()

# newdata1 = pd.get_dummies(newdata1, columns=['realestate_type'])
# nle = LabelEncoder()
# newdata1['realestate_type'] = nle.fit_transform(newdata1['realestate_type'])

# Removie the outliers
# from sklearn.ensemble import IsolationForest

# clf = IsolationForest(max_samples = 100, random_state = 42)
# clf.fit(newdata1)
# y_noano = clf.predict(newdata1)
# y_noano = pd.DataFrame(y_noano, columns = ['Top'])
# y_noano

# from sklearn.model_selection import train_test_split

# from sklearn.neural_network import MLPRegressor
# from sklearn.ensemble import ExtraTreesRegressor
# from mlxtend.regressor import StackingCVRegressor

# from sklearn.svm import SVR
# from sklearn.linear_model import Lasso
# from sklearn.ensemble import RandomForestRegressor
# from sklearn.ensemble import GradientBoostingRegressor
# from xgboost import XGBRegressor
# from sklearn.linear_model import LinearRegression
# from sklearn.neighbors import KNeighborsRegressor
# from sklearn.metrics import mean_squared_error

# from sklearn.model_selection import RandomizedSearchCV


# from tensorflow.keras.models import Sequential
# from tensorflow.keras.layers import Dense

# from sklearn.preprocessing import StandardScaler
# Y = newdata1["price"].astype('float')
# X = newdata1.drop(columns =["price"])

# x_train, x_test, y_train, y_test = train_test_split(X, Y, test_size=0.25, random_state=42 )

# x_train.shape[1]

# et  = ExtraTreesRegressor(n_estimators=950 ,  max_features = 'auto', max_leaf_nodes=None, n_jobs= -1, random_state = 0, verbose = 0)
# gbr = GradientBoostingRegressor()
# lasso = Lasso()
# xgbr = XGBRegressor()
# svr = SVR(kernel= 'rbf', gamma= 'auto', tol=0.001, C=100.0, max_iter=-1)
# rf = RandomForestRegressor(n_estimators=900,  random_state=0)
# lr = LinearRegression(fit_intercept=True, normalize=True, copy_X=True, n_jobs=-1)
# knnR = KNeighborsRegressor(n_neighbors=20, n_jobs=-1)
# reg = StackingCVRegressor(regressors=[xgbr , gbr, lr, et], meta_regressor=lr)
# reg.fit(x_train.values, y_train.values)

# tuned_params = {'max_depth': [1, 2, 3, 4, 5], 'learning_rate': [0.01, 0.05, 0.1], 'n_estimators': [100, 200, 300, 400, 500], 'reg_lambda': [0.001, 0.1, 1.0, 10.0, 100.0]}
# reg = RandomizedSearchCV(XGBRegressor(), tuned_params, n_iter=20, scoring = 'neg_mean_absolute_error', cv=5, n_jobs=-1)
# reg.fit(x_train, y_train)

# reg=GradientBoostingRegressor()
# reg.fit(x_train, y_train)

# reg = Sequential()
# reg.add(Dense(x_train.shape[1], input_dim=x_train.shape[1], kernel_initializer='normal', activation='relu'))
# reg.add(Dense(1, kernel_initializer='normal'))
# reg.compile(loss='mean_squared_error', optimizer='adam',metrics='accuracy')
# reg.fit(x=x_train, y=y_train, epochs=100, verbose=0)

# print('Test')
# print(reg.score(x_test.values, y_test.values))
# # print('\nRMSLE')
# # print(sqrt(mean_squared_error(reg.predict(x_test.values), y_test)))
# print('\nTrain')
# print(reg.score(x_train.values, y_train.values))

# y_test.dtypes

# score, acc = reg.evaluate(x_test.values, y_test.values
#                             )
# print('Test score:', score)
# print('Test accuracy:', acc)

newdata2 = newdata[newdata["transaction_type"] == "thuê"]

newdata2 = newdata2.drop(columns =['index','geo_location','interior_floor','addr_street','addr_ward',"area_unit","date","email","interior_room","legal","phone","position","potential","realestate_url","start_url","surrounding","surrounding_characteristics","surrounding_name","title","transaction_type","website_name","price_unit"])

newdata2.info()

newdata2.reset_index(drop = True, inplace = True)
train_numerical2 = newdata2.select_dtypes(exclude=['object','datetime64[ns]'])

train_categoric2 = newdata2.select_dtypes(include=['object'])

clf2 = IsolationForest(max_samples = 100, random_state = 42)
clf2.fit(train_numerical2)
y_noano2 = clf2.predict(train_numerical2)
y_noano2 = pd.DataFrame(y_noano2, columns = ['Top'])
y_noano2[y_noano2['Top'] == 1]

train_numerical2 = train_numerical2.iloc[y_noano2[y_noano2['Top'] == 1].index.values]
train_numerical2.reset_index(drop = True, inplace = True)

train_categoric2 = train_categoric2.iloc[y_noano2[y_noano2['Top'] == 1].index.values]
train_categoric2.reset_index(drop = True, inplace = True)

newdata2 = newdata2.iloc[y_noano2[y_noano2['Top'] == 1].index.values]
newdata2.reset_index(drop = True, inplace = True)

col_train_num2 = list(train_numerical2.columns)
col_train_num_bis2 = list(train_numerical2.columns)

col_train_cat2 = list(train_categoric2.columns)

col_train_num_bis2.remove('price')

mat_train2 = np.matrix(train_numerical2)
# mat_test  = np.matrix(test_numerical)
mat_new2 = np.matrix(train_numerical2.drop('price',axis = 1))
mat_y2 = np.array(newdata2.price)

prepro_y2 = MinMaxScaler()
prepro_y2.fit([mat_y2])

prepro2 = MinMaxScaler()
prepro2.fit(mat_train2)

prepro_test2 = MinMaxScaler()
prepro_test2.fit(mat_new2)

train_num_scale2 = pd.DataFrame(prepro2.transform(mat_train2),columns = col_train_num2)
# test_num_scale  = pd.DataFrame(prepro_test.transform(mat_test),columns = col_train_num_bis)
newdata2[col_train_num2] = pd.DataFrame(prepro2.transform(mat_train2),columns = col_train_num2)

COLUMNS2 = col_train_num2
FEATURES2 = col_train_num_bis2
LABEL2 = "price"

FEATURES_CAT2 = col_train_cat2
FEATURES_CAT2

engineered_features2 = []

for continuous_feature in FEATURES2:
    engineered_features2.append(
        # tf.contrib.layers.real_valued_column(continuous_feature))
        tf.feature_column.numeric_column(continuous_feature))
for categorical_feature in FEATURES_CAT2:
    # sparse_column = tf.contrib.layers.sparse_column_with_hash_bucket(
    #     categorical_feature, hash_bucket_size=1000)
    sparse_column = tf.feature_column.categorical_column_with_hash_bucket(
        categorical_feature, hash_bucket_size=1000)

    engineered_features2.append(tf.feature_column.embedding_column(categorical_column=sparse_column, dimension=4,combiner="sum"))

training_set2 = newdata2[FEATURES2 + FEATURES_CAT2]
prediction_set2 = newdata2.price

x_train2, x_test2, y_train2, y_test2 = train_test_split(training_set2[FEATURES2 + FEATURES_CAT2] ,
                                                    prediction_set2, test_size=0.33, random_state=42)

y_train2 = pd.DataFrame(y_train2, columns = [LABEL2])
training_set2 = pd.DataFrame(x_train2, columns = FEATURES2 + FEATURES_CAT2).merge(y_train2, left_index = True, right_index = True)

y_test2 = pd.DataFrame(y_test2, columns = [LABEL2])
testing_set2 = pd.DataFrame(x_test2, columns = FEATURES2 + FEATURES_CAT2).merge(y_test2, left_index = True, right_index = True)
training_set2[FEATURES_CAT2] = training_set2[FEATURES_CAT2].applymap(str)
testing_set2[FEATURES_CAT2] = testing_set2[FEATURES_CAT2].applymap(str)

regressor2 = tf.estimator.DNNRegressor(feature_columns = engineered_features2,
                                          activation_fn = tf.nn.relu6, hidden_units=[1], optimizer=tf.keras.optimizers.SGD( learning_rate= 0.025), dropout=0.01,model_dir = "./thue")

train1 = regressor2.train(input_fn = lambda:input_fn_new(training_set2) ,steps = 2000)
# print("train_accuracy",train1['prediction/mean'])

ev2 = regressor2.evaluate(input_fn=lambda: input_fn_new(testing_set2, training = True), steps=1)
print("eval_accuracy",ev2['prediction/mean'])

# newdata2 = newdata2.drop(columns =['addr_street','addr_ward',"area_unit","date","email","interior_floor","interior_room","legal","phone","position","potential","realestate_url","start_url","surrounding","surrounding_characteristics","surrounding_name","title","transaction_type","website_name","price_unit"])

# newdata2 = pd.get_dummies(newdata2, columns=['realestate_type'])
# nnle = LabelEncoder()
# newdata2['realestate_type'] = nnle.fit_transform(newdata2['realestate_type'])

# Y1 = newdata2["price"].astype('float')
# X1 = newdata2.drop(columns =["price"])

# x_train1, x_test1, y_train1, y_test1 = train_test_split(X1, Y1, test_size=0.25, random_state=42 )

# et1  = ExtraTreesRegressor(n_estimators=950 ,  max_features = 'auto', max_leaf_nodes=None, n_jobs= -1, random_state = 0, verbose = 0)
# gbr1 = GradientBoostingRegressor()
# lasso = Lasso()
# xgbr1 = XGBRegressor()
# svr = SVR(kernel= 'rbf', gamma= 'auto', tol=0.001, C=100.0, max_iter=-1)
# rf1 = RandomForestRegressor(n_estimators=900,  random_state=0)
# lr1 = LinearRegression(fit_intercept=True, normalize=True, copy_X=True, n_jobs=-1)
# knnR = KNeighborsRegressor(n_neighbors=20, n_jobs=-1)
# reg1 = StackingCVRegressor(regressors=[xgb1r , gbr1, lr1, et1], meta_regressor=rf1)
# reg1.fit(x_train1.values, y_train1.values)

# print('Test')
# print(reg1.score(x_test.values, y_test.values))
# # print('\nRMSLE')
# # print(sqrt(mean_squared_error(reg.predict(x_test.values), y_test)))
# print('\nTrain')
# print(reg1.score(x_train.values, y_train.values))

# reg1 = Sequential()
# reg1.add(Dense(x_train1.shape[1], input_dim=x_train1.shape[1], kernel_initializer='normal', activation='relu'))
# reg1.add(Dense(1, kernel_initializer='normal'))
# reg1.compile(loss='mean_squared_error', optimizer='adam',metrics='accuracy')
# reg1.fit(x=x_train1, y=y_train1)

# score1, acc1 = reg1.evaluate(x_test1.values, y_test1.values )
# print('Test score:', score1)
# print('Test accuracy:', acc1)